# Create a customer address

To [create](https://docs.commercelayer.io/core/creating-resources) a new customer address, send a `POST` request to the `/api/customer_addresses` endpoint, passing the resource arguments in the request body.

## Request

**POST** <https://yourdomain.commercelayer.io/api/customer\\_addresses>

### Arguments

| Body Parameter                   | Type     | Required |
| -------------------------------- | -------- | -------- |
| **type**                         | `string` | Required |
| attributes.**customer\_email**   | `string` | Required |
| attributes.**reference**         | `string` | Optional |
| attributes.**reference\_origin** | `string` | Optional |
| attributes.**metadata**          | `object` | Optional |
| relationships.**customer**       | `object` | Required |
| relationships.**address**        | `object` | Required |

### Example

{% tabs %}
{% tab title="Request" %}
The following request creates a new customer address:

```shell
curl -g -X POST \
  'https://yourdomain.commercelayer.io/api/customer_addresses' \
  -H 'Accept: application/vnd.api+json' \
  -H 'Authorization: Bearer your-access-token' \
  -H 'Content-Type: application/vnd.api+json' \
  -d '{
  "data": {
    "type": "customer_addresses",
    "attributes": {
      "customer_email": "john@example.com"
    },
    "relationships": {
      "customer": {
        "data": {
          "type": "customers",
          "id": "ABCRtyUpBa"
        }
      },
      "address": {
        "data": {
          "type": "addresses",
          "id": "BCDRtyUpBa"
        }
      }
    }
  }
}'
```

{% endtab %}

{% tab title="Response" %}
On success, the API responds with a `201 Created` status code, returning the created resource object:

```json
{
  "data": {
    "id": "XAyRWNUzyN",
    "type": "customer_addresses",
    "links": {
      "self": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN"
    },
    "attributes": {
      "name": "John Smith, 2883 Geraldine Lane Apt.23, 10013 New York NY (US) (212) 646-338-1228",
      "customer_email": "john@example.com",
      "created_at": "2018-01-01T12:00:00.000Z",
      "updated_at": "2018-01-01T12:00:00.000Z",
      "reference": "ANY-EXTERNAL-REFEFERNCE",
      "reference_origin": "ANY-EXTERNAL-REFEFERNCE-ORIGIN",
      "metadata": {
        "foo": "bar"
      }
    },
    "relationships": {
      "customer": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/relationships/customer",
          "related": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/customer"
        }
      },
      "address": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/relationships/address",
          "related": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/address"
        }
      },
      "events": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/relationships/events",
          "related": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/events"
        }
      },
      "event_stores": {
        "links": {
          "self": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/relationships/event_stores",
          "related": "https://yourdomain.commercelayer.io/api/customer_addresses/XAyRWNUzyN/event_stores"
        }
      }
    },
    "meta": {
      "mode": "test",
      "organization_id": "xRRkjDFafe",
      "trace_id": "69abaa3545913c78132e5578bd26208d44aa9043647d78698fd0021f3958cd74"
    }
  }
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.commercelayer.io/core-api-reference/customer_addresses/create.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
